'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.builtinClientEvents = exports.builtinEvents = undefined;

var _builtinClientEvents;

var _events = require('../events');

var Events = _interopRequireWildcard(_events);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } /**
                                                                                                                                                                                                                   * Builtin clientside events.
                                                                                                                                                                                                                   */

var builtinEvents = exports.builtinEvents = _defineProperty({}, Events.MESSAGE, function (monsterr, payload) {
  if (typeof payload === 'string') {
    monsterr.getChat().append(payload);
  } else {
    var msg = payload.msg,
        name = payload.name,
        sender = payload.sender;

    monsterr.getChat().append(msg, name, sender === monsterr.getId());
  }
});

var builtinClientEvents = exports.builtinClientEvents = (_builtinClientEvents = {}, _defineProperty(_builtinClientEvents, Events.START_STAGE, function (monsterr, stageNo) {
  monsterr.getStageManager().startStage(stageNo);
}), _defineProperty(_builtinClientEvents, Events.END_STAGE, function (monsterr, stageNo) {
  monsterr.getStageManager().endStage(stageNo);
}), _defineProperty(_builtinClientEvents, Events.SET_NAME, function (monsterr, _ref) {
  var name = _ref.name,
      prevName = _ref.prevName;

  monsterr.getChat().rename(prevName, name);
}), _defineProperty(_builtinClientEvents, Events.RENAME, function (monsterr, _ref2) {
  var name = _ref2.name,
      prevName = _ref2.prevName;

  monsterr.getChat().rename(prevName, name);
}), _builtinClientEvents);