'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.createHttpServer = createHttpServer;
exports.createSocketServer = createSocketServer;

var _events = require('events');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// const session = require('express-session')({
//   secret: 'monstrous_secret',
//   resave: true,
//   saveUninitialized: true
// })
// const sharedSession = require('express-socket.io-session')

var express = require('express');
var app = express();
var path = require('path');
var http = require('http').Server(app);
var io = require('socket.io')(http);

// Use sessions
// app.use(session)
// io.use(sharedSession(session))

// We serve static from /client. This allows games to easily include static assets by putting them in the /client directory.
app.use(express.static('dist'));
app.use('/assets', express.static('assets'));

/* Routes */
app.get('/', function (req, res) {
  return res.sendFile(path.join(__dirname, '../index.html'));
});
app.get('/admin', function (req, res) {
  return res.sendFile(path.join(__dirname, '../index.html'));
});
// app.get('/admin', (req, res) => res.sendFile(path.join(__dirname, '../admin.html')))
app.get('/fabric', function (req, res) {
  return res.sendFile(path.join(__dirname, '../imports', 'fabric-2.2.3.js'));
});

// Options are passed through to createServer inside of module
function createHttpServer(_ref) {
  var _ref$port = _ref.port,
      port = _ref$port === undefined ? 3000 : _ref$port;

  http.listen(port, function () {
    console.log('listening on ' + port);
  });
}

var SocketServer = function (_EventEmitter) {
  _inherits(SocketServer, _EventEmitter);

  function SocketServer() {
    _classCallCheck(this, SocketServer);

    var _this = _possibleConstructorReturn(this, (SocketServer.__proto__ || Object.getPrototypeOf(SocketServer)).call(this));

    _this.clientsNsp = io.of('/clients');
    _this.adminNsp = io.of('/admin');

    /** Connections */
    _this.clientsNsp.on('connection', function (socket) {
      _this.emit('connect', socket.id);
      var withClientId = function withClientId(cmdOrEvent) {
        return _extends({}, cmdOrEvent, { clientId: socket.id });
      };

      // server.clientConnected(socket.id)
      socket.on('cmd', function (cmd) {
        return _this.emit('cmd', withClientId(cmd));
      });
      socket.on('event', function (event) {
        return _this.emit('event', withClientId(event));
      });

      socket.on('disconnect', function () {
        socket.removeAllListeners();
        _this.emit('disconnect', socket.id);
        // server.clientDisconnected(socket.id)
      });
    });

    _this.adminNsp.on('connection', function (socket) {
      socket.on('cmd', function (cmd) {
        return _this.emit('cmd', cmd);
      });
      socket.on('disconnect', function () {
        return socket.removeAllListeners();
      });
    });
    return _this;
  }

  _createClass(SocketServer, [{
    key: 'send',
    value: function send() {
      var _this2 = this;

      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'event';
      var obj = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      return {
        toAll: function toAll() {
          return _this2.clientsNsp.emit(type, obj);
        },
        toClients: function toClients() {
          var clients = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
          return clients.length && clients.reduce(function (chain, client) {
            return chain.to(client);
          }, _this2.clientsNsp).emit(type, obj);
        },
        toAdmin: function toAdmin() {
          return _this2.adminNsp.emit(type, obj);
        }
      };
    }
  }, {
    key: 'sendCommand',
    value: function sendCommand(cmd) {
      return this.send('cmd', cmd);
    }
  }, {
    key: 'sendEvent',
    value: function sendEvent(event) {
      return this.send('event', event);
    }
  }]);

  return SocketServer;
}(_events.EventEmitter);

function createSocketServer() {
  return new SocketServer();
}