"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = runStage;
function runStage(_ref) {
  var setup = _ref.setup,
      teardown = _ref.teardown,
      timeout = _ref.timeout,
      _ref$context = _ref.context,
      context = _ref$context === undefined ? {} : _ref$context,
      _ref$options = _ref.options;
  _ref$options = _ref$options === undefined ? {} : _ref$options;
  var duration = _ref$options.duration;

  var timer = void 0;
  var terminated = false;

  function modifiedTeardown() {
    var byTimer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    teardown && teardown(context);
    byTimer && timeout && timeout();
  }

  function terminateStage() {
    var byTimer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    if (terminated) {
      return;
    }

    terminated = true;
    timer && clearTimeout(timer);
    modifiedTeardown(byTimer);
  }

  if (duration) {
    timer = setTimeout(function () {
      return terminateStage(true);
    }, duration);
  }

  setup && setup(context);

  return function () {
    return terminateStage(false);
  };
}