'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.builtinEvents = undefined;

var _builtinEvents;

var _events = require('../events');

var Events = _interopRequireWildcard(_events);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } /**
                                                                                                                                                                                                                   * Built in serverside events.
                                                                                                                                                                                                                   */

var builtinEvents = exports.builtinEvents = (_builtinEvents = {}, _defineProperty(_builtinEvents, Events.SET_NAME, function (monsterr, clientId, name) {
  monsterr.setName(clientId, name);
}), _defineProperty(_builtinEvents, Events.MESSAGE, function (monsterr, clientId, msg) {
  monsterr.send(Events.MESSAGE, { msg: msg, name: monsterr.getName(clientId), sender: clientId }).toNeighboursOf(clientId);
}), _defineProperty(_builtinEvents, Events.LOG, function (monsterr, _, json) {
  monsterr.log(json.msg, json.fileOrExtra, json.extra);
}), _defineProperty(_builtinEvents, Events.STAGE_FINISHED, function (monsterr, clientId, stageNo) {
  monsterr.playerFinishedStage(clientId, stageNo);
}), _defineProperty(_builtinEvents, Events.CLIENT_CONNECTED, function (monsterr, clientId) {
  console.log(clientId, 'connected!');
  monsterr.addPlayer(clientId);
}), _defineProperty(_builtinEvents, Events.CLIENT_RECONNECTED, function (monsterr, clientId) {
  console.log(clientId, 'reconnected!');
  monsterr.addPlayer(clientId);
}), _defineProperty(_builtinEvents, Events.CLIENT_DISCONNECTED, function (monsterr, clientId) {
  console.log(clientId, 'disconnected!');
  monsterr.removePlayer(clientId);
}), _defineProperty(_builtinEvents, Events.START_STAGE, function (monsterr, _, stage) {
  monsterr.send(Events.START_STAGE, stage.number).toAll();
}), _defineProperty(_builtinEvents, Events.END_STAGE, function (monsterr, _, stage) {
  monsterr.send(Events.END_STAGE, stage.number).toAll();
}), _defineProperty(_builtinEvents, Events.GAME_OVER, function (monsterr) {
  monsterr.send(Events.GAME_OVER).toAll();
}), _builtinEvents);