"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.repeat = repeat;
exports.withDuration = withDuration;
exports.withName = withName;
/**
 * Repeat a stage 'n' times.
 * @param {{}} stage
 * @param {number} n
 * @param {string[]} names names to apply to stages (default 'unnamed')
 */
function repeat() {
  var stage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var n = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;
  var names = arguments[2];

  // _.cloneDeep(stage)?
  return Array(n).fill(stage).map(function (stage, idx) {
    return withName(stage, names && names[idx]);
  });
}

/**
 * Exact copy of stage, but with duration set.
 * @param {{}} stage
 * @param {number} duration
 */
function withDuration() {
  var stage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 10000;

  return _extends({}, stage, {
    options: _extends({}, stage.options, {
      duration: duration
    })
  });
}

/**
 * Exact copy of stage, but with name.
 * @param {{}} stage
 * @param {string} name
 */
function withName() {
  var stage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var name = arguments[1];

  return name ? _extends({}, stage, {
    name: name
  }) : stage;
}